SystemOrganization addCategory: #PharoGenesis!
SystemOrganization addCategory: #'PharoGenesis-Tests'!

TestCase subclass: #StampParsingTests
	instanceVariableNames: 'gcr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis-Tests'!

!StampParsingTests methodsFor: 'running' stamp: 'MaxLeske 10/30/2010 16:44'!
setUp
	gcr := GitChangeRecord new! !

!StampParsingTests methodsFor: 'tests' stamp: 'MML 9/15/2010 20:57'!
testDateFrom
	self assert: (gcr dateFrom: '10/4/97 00:08 di') = '10/4/1997'.
	self assert: (gcr dateFrom: '00:08 10/4/97 di') = '10/4/1997'.
	self assert: (gcr dateFrom: 'di 00:08 10/4/97') = '10/4/1997'.
	self assert: (gcr dateFrom: 'di 10/4/97 00:08') = '10/4/1997'.
	self assert: (gcr dateFrom: '00:08 di 10/4/97') = '10/4/1997'.
	self assert: (gcr dateFrom: '10/4/97 di 00:08') = '10/4/1997'.
	self assert: (gcr dateFrom: 'di 00:08') isEmpty! !

!StampParsingTests methodsFor: 'tests' stamp: 'MML 9/15/2010 20:58'!
testResolveStamp
	| template timeStamp |
	timeStamp := (TimeStamp fromString: '4/6/1997 00:08') offset: Duration zero.
	template := timeStamp asUnixTime asString , ' di'.
	
	self assert: (gcr resolveStamp: '4/6/97 00:08 di') = template! !

Object subclass: #GitChangeRecord
	instanceVariableNames: 'selector changeRecord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

GitChangeRecord subclass: #GCRClassComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GCRClassComment class methodsFor: 'private' stamp: 'MML 9/15/2010 20:36'!
recordType
	^ #classComment! !

!GCRClassComment methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:17'!
objectPath: targetReference
	^ (self basePath: targetReference) /
		'comment' /
		'comment.cs'! !

GitChangeRecord subclass: #GCRDoIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GCRDoIt class methodsFor: 'private' stamp: 'MML 9/15/2010 20:37'!
recordType
	^ #doIt! !

!GCRDoIt methodsFor: 'internal-accessors' stamp: 'MaxLeske 9/16/2010 13:45'!
methodClassName: aString
	changeRecord instVarNamed: 'class' put: aString! !

!GCRDoIt methodsFor: 'internal-accessors' stamp: 'MaxLeske 9/16/2010 13:57'!
methodSelector: aString
	selector := aString! !

GCRDoIt subclass: #GCRDoItClassCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GCRDoItClassCreation methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:46'!
objectPath: targetReference
	^ (self basePath: targetReference) /
		'instance.cs'! !

GCRDoIt subclass: #GCRDoItMetaClassCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GCRDoItMetaClassCreation methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:52'!
objectPath: targetReference
	^ (self basePath: targetReference) /
		'class.cs'! !

GitChangeRecord subclass: #GCRMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GCRMethod class methodsFor: 'private' stamp: 'MML 9/15/2010 20:42'!
recordType
	^ #method! !

!GCRMethod methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:16'!
instanceOrClassDir
	^ self isMetaClassChange
		ifTrue: [ 'class' ]
		ifFalse: [ 'instance' ]! !

!GCRMethod methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:15'!
objectPath: targetReference
	^ (self basePath: targetReference) /
		self instanceOrClassDir /
		self validCategory /
		self validMethodSelector /
		self validMethodSelector , 'cs'
		! !

GitChangeRecord subclass: #GCRPreamble
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GCRPreamble class methodsFor: 'private' stamp: 'MML 9/15/2010 20:42'!
recordType
	^ #preamble! !

!GitChangeRecord class methodsFor: 'initialization' stamp: 'MML 9/15/2010 20:39'!
from: aChangeRecord
	self allSubclassesDo: [ :each |
		aChangeRecord type = each recordType ifTrue: [ 
			^ each new changeRecord: aChangeRecord ] ]! !

!GitChangeRecord class methodsFor: 'private' stamp: 'MML 9/15/2010 20:33'!
recordType
	self subclassResponsibility! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:44'!
asMethodDefinition
	^ self changeRecord asMethodDefinition! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 10/30/2010 17:13'!
author
	^ (self stamp subStrings: ' ') second! !

!GitChangeRecord methodsFor: 'private' stamp: 'MaxLeske 9/21/2010 17:36'!
basePath: targetReference
	^ targetReference /
		self methodClassName
	! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:43'!
category
	^ self changeRecord category! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 8/16/2010 16:26'!
changeRecord
	^ changeRecord! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 8/16/2010 16:26'!
changeRecord: aChangeRecord
	changeRecord := aChangeRecord! !

!GitChangeRecord methodsFor: 'parsing' stamp: 'MaxLeske 10/30/2010 11:47'!
dateFrom: aStamp
	| dateMatch year dateParts matches |
	matches := '\d+/\d+/\d+' asRegex matchesIn: aStamp.
	dateMatch := matches isEmpty
		ifTrue: [ nil ]
		ifFalse: [ matches first ].
	dateMatch isEmptyOrNil
		ifTrue: [ ^ '' ].
	dateParts := dateMatch subStrings: '/'.
	year := dateParts third.
	year size = 2
		ifTrue: [ year := '19' , year ].
	^ dateParts first , '/' , dateParts second , '/' , year! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:42'!
isMetaClassChange
	^ self changeRecord isMetaClassChange! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:41'!
methodClass
	^ self changeRecord methodClass! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:41'!
methodClassName
	^ self changeRecord methodClassName! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:58'!
methodSelector
	^ selector ifNil: [ self changeRecord methodSelector ]! !

!GitChangeRecord methodsFor: 'converting' stamp: 'MML 9/15/2010 21:06'!
mutator
	^ self recordType asMutator! !

!GitChangeRecord methodsFor: 'parsing' stamp: 'MML 9/15/2010 20:25'!
nameFrom: aStamp
	| result |
	result := ''.
	aStamp regex: '[a-zA-Z]+' matchesDo: [ :match | match size > result size ifTrue: [ result := match ] ].
	^ result
	
	! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:08'!
objectPath: targetReference
	self subclassResponsibility! !

!GitChangeRecord methodsFor: 'private' stamp: 'MML 9/15/2010 21:06'!
recordType
	^ self class recordType! !

!GitChangeRecord methodsFor: 'parsing' stamp: 'MaxLeske 9/16/2010 15:56'!
resolveStamp: aStamp
	"stamp format: 'TPR 5/12/1998 22:48', '6/11/97 09:18 di'"
	
	|  name date time timeStamp |
	aStamp isEmptyOrNil ifTrue: [ ^ '0' ].
	
	date := self dateFrom: aStamp.
	name := self nameFrom: aStamp.
	time := self timeFrom: aStamp.
	(date isEmpty or: [ time isEmpty ])
		ifTrue: [ ^ '0' , name ].	
	timeStamp := (TimeStamp fromString: (date , ' ' , time)) offset: Duration zero.

	^  timeStamp asUnixTime asString , ' ' , name! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MML 9/15/2010 21:08'!
stamp
	^ self resolveStamp: self changeRecord stamp! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:39'!
string
	^ self changeRecord string! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:39'!
text
	^ self changeRecord text! !

!GitChangeRecord methodsFor: 'parsing' stamp: 'MML 9/15/2010 20:25'!
timeFrom: aStamp
	| result |
	result := aStamp allRegexMatches: '\d\d\:\d\d'.
	result isEmptyOrNil ifTrue: [ ^ '' ].
	^ result first
	
	! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 16:22'!
timeStamp
	| unixTime |
	unixTime := (self stamp subStrings: ' ') first asInteger.
	^ (TimeStamp fromUnixTime: unixTime) offset: Duration zero! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/14/2010 21:38'!
type
	^ self changeRecord type! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:10'!
validCategory
	^ self validNodeName: self category! !

!GitChangeRecord methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:10'!
validMethodSelector
	^ self validNodeName: self methodSelector! !

!GitChangeRecord methodsFor: 'parsing' stamp: 'MaxLeske 9/16/2010 13:10'!
validNodeName: aSymbol
	^ aSymbol asString encodeForHTTP! !

Object subclass: #GitSourceImporter
	instanceVariableNames: 'target searcher parser gitFS'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoGenesis'!

!GitSourceImporter methodsFor: 'private' stamp: 'MaxLeske 10/30/2010 13:31'!
changeRecordsFor: aReference do: aBlock displayingProgress: aString
	| changes |
	changes := FileStream oldFileNamed: aReference path asString do: [ :sourceStream | 
		sourceStream converter: Latin1TextConverter new.
		ChangeSet scanFile: sourceStream from: 0 to: sourceStream size ].
	
	aString isEmptyOrNil
		ifTrue: [
			changes 
				do: [ :change | 
					aBlock value: (GitChangeRecord from: change) ] ]
		ifFalse: [
			changes 
				do: [ :change | 
					aBlock value: (GitChangeRecord from: change) ] 
				displayingProgress: aString ]! !

!GitSourceImporter methodsFor: 'record types' stamp: 'MaxLeske 9/16/2010 13:20'!
classComment: aChangeRecord
	self 
		write: aChangeRecord string 
		to: (aChangeRecord objectPath: target)
		withStamp: aChangeRecord stamp! !

!GitSourceImporter methodsFor: 'parsing' stamp: 'MaxLeske 7/27/2010 12:19'!
classCreation
	^ '`@superclass `subclass: `#subclass
		instanceVariableNames: `#instVars
		classVariableNames: `#classVars
		poolDictionaries: `#poolDicts
		category: `#category'! !

!GitSourceImporter methodsFor: 'public' stamp: 'MaxLeske 10/30/2010 17:20'!
copySource: sourceReference to: targetReference
	target := targetReference.
	
	self 
		changeRecordsFor: sourceReference
		do:[ :change |
			self processChange: change ]
		displayingProgress: 'Processing ' , sourceReference basename surroundedBySingleQuotes! !

!GitSourceImporter methodsFor: 'public' stamp: 'MaxLeske 8/3/2010 18:10'!
createRepositoryAt: targetReference fromFileNames: fileNames in: sourceReference
	| files |
	files := fileNames collect: [ :filename | sourceReference / filename ].
	self 
		createRepositoryAt: targetReference 
		fromFiles: files! !

!GitSourceImporter methodsFor: 'public' stamp: 'MaxLeske 10/30/2010 16:49'!
createRepositoryAt: targetReference fromFiles: fileReferences
	| repo |
	repo := FSGitRepository on: targetReference / 'pharogenesis'.
	gitFS := repo head.
	
	fileReferences do: [ :file |
		(file basename endsWith: '.sources')
			ifTrue: [ self singleCommitSources: file  ]
			ifFalse: [ self incrementallyCommitChanges: file ] ].! !

!GitSourceImporter methodsFor: 'record types' stamp: 'MaxLeske 10/30/2010 16:45'!
doIt: aChangeRecord
	| tree |
	self searcher initialize.
	tree := [ self parser parseExpression: aChangeRecord string ]
		on: Exception do: [ :ex | ^ nil ].

	self searcher 
		matches: self classCreation
		do: [ :node :answer |
			aChangeRecord methodClassName: node arguments first value asString.
			self 
				write: node formattedCode 
				to:  (aChangeRecord objectPath: target)
				withStamp: aChangeRecord stamp ];
		
		matches: self metaClassCreation
		do: [ :node :answer |
			aChangeRecord methodClassName: node receiver receiver name asString.
			self 
				write: node formattedCode 
				to: (aChangeRecord objectPath: target)
				withStamp: aChangeRecord stamp ];
		
		matches: self methodRemoval
		do: [ :node :answer |
			aChangeRecord methodSelector: node arguments first value asString.
			aChangeRecord methodClassName: node receiver name asString.
			^ self 
				memorizeSelector: aChangeRecord methodSelector 
				forDeletionInClass: aChangeRecord methodClassName
				instance: true ];
		executeTree: tree.
	
	tree isMessage ifTrue: [ ^ self ].
	tree isSequence ifTrue: [ ^ self ].
	"self halt"! !

!GitSourceImporter methodsFor: 'private' stamp: 'MaxLeske 10/30/2010 17:09'!
incrementallyCommitChanges: aReference
	self
		changeRecordsFor: aReference
		do: [ :change |
			self processChange: change.
			self setStampFrom: change.
			gitFS commit: 'no message' ]
		displayingProgress: 'creating commits...'.
		
	gitFS 
		tagRevision: gitFS parents first 
		with: (aReference basename subStrings: '.') first! !

!GitSourceImporter methodsFor: 'parsing' stamp: 'MaxLeske 7/27/2010 12:20'!
metaClassCreation
	^ '`class class instanceVariableNames: `#instVars'! !

!GitSourceImporter methodsFor: 'record types' stamp: 'MaxLeske 9/16/2010 13:20'!
method: aChangeRecord
	self 
		write: aChangeRecord string 
		to: (aChangeRecord objectPath: target)
		withStamp: aChangeRecord stamp! !

!GitSourceImporter methodsFor: 'parsing' stamp: 'MaxLeske 7/27/2010 12:21'!
methodRemoval
	^ '`class removeSelector: `#selector'! !

!GitSourceImporter methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:34'!
parser
	^ parser ifNil: [ parser := RBParser new ]! !

!GitSourceImporter methodsFor: 'record types' stamp: 'MaxLeske 7/26/2010 20:21'!
preamble: aChangeRecord
	"ignore".! !

!GitSourceImporter methodsFor: 'private' stamp: 'MaxLeske 10/30/2010 13:38'!
processChange: aChangeRecord
	self
		perform: aChangeRecord mutator
		with: aChangeRecord! !

!GitSourceImporter methodsFor: 'accessing' stamp: 'MaxLeske 9/16/2010 13:33'!
searcher
	^ searcher ifNil: [ searcher := RBParseTreeSearcher new ]! !

!GitSourceImporter methodsFor: 'private' stamp: 'MaxLeske 10/30/2010 17:19'!
setStampFrom: aChange
	| stamp |
	stamp := GitStamp new
		name: aChange author;
		timeStamp: aChange timeStamp;
		yourself.
		
	gitFS
		setAuthor: stamp;
		setCommitter: stamp! !

!GitSourceImporter methodsFor: 'private' stamp: 'MaxLeske 10/30/2010 17:19'!
singleCommitSources: sourceReference
	| subStrings author committer |
	self 
		copySource: sourceReference
		to: gitFS root.
	subStrings := sourceReference basename subStrings: '.'.
	
	author := GitStamp new
		name: 'unspecified';
		email: 'unspeciefied';
		yourself.
	committer := GitStamp new
		name: 'Max Leske';
		email: 'maxleske@gmail.com'
		yourself.
	gitFS
		setAuthor: author;
		setCommitter: committer.	
	
	gitFS
		commit: 'single commit for ', subStrings first
	 	andTag: subStrings first! !

!GitSourceImporter methodsFor: 'private' stamp: 'MaxLeske 10/30/2010 11:49'!
write: aString to: aReference withStamp: aStamp
	aString species = WideString ifTrue: [ ^ self ].
	
	aReference parent ensureDirectory.
	aReference writeStreamDo: [ :stream | stream nextPutAll: aString ].
	aReference parent / 'stamp.txt' writeStreamDo: [ :stream | stream nextPutAll: aStamp ]! !
